package com.house365.xxx.house.word.search.util;


public class DistanceCalculate {
	public static int getWordDistance(String word1, String word2) {
		int distance = 0;
		char[] mychar1 = word1.toCharArray();
		char[] mychar2 = word2.toCharArray();
		int len1 = mychar1.length;
		int len2 = mychar2.length;
		int cost;
		int boundaryx = len1 + 1;
		int boundaryy = len2 + 1;
		int[][] dis = new int[boundaryx][boundaryy];
		for (int i = 0; i <= len1; i++)
			dis[i][0] = i;
		for (int j = 0; j <= len2; j++)
			dis[0][j] = j;
		for (int i = 1; i <= len1; i++) {
			for (int j = 1; j <= len2; j++) {
				if (mychar1[i - 1] == mychar2[j - 1])
					cost = 0;
				else
					cost = 1;
				dis[i][j] = getMin(dis[i - 1][j] + 1, dis[i][j - 1] + 1,
						dis[i - 1][j - 1] + cost);
			}
		}
		distance = dis[len1][len2];
		return distance;
	}

	public static int getMin(int a, int b, int c) {
		int min = a;
		if (b < min)
			min = b;
		if (c < min)
			min = c;
		return min;
	}

	
	public static float getMin(float a, float b, float c) {
		float min = a;
		if (b < min)
			min = b;
		if (c < min)
			min = c;
		return min;
	}

}
